Index: /branches/2520_PersistenceReintegration/HeuristicLab.Operators.Views.GraphVisualization/3.3/General/IConnectionInfo.cs
===================================================================
--- /branches/2520_PersistenceReintegration/HeuristicLab.Operators.Views.GraphVisualization/3.3/General/IConnectionInfo.cs	(revision 16475)
+++ /branches/2520_PersistenceReintegration/HeuristicLab.Operators.Views.GraphVisualization/3.3/General/IConnectionInfo.cs	(revision 16476)
@@ -22,6 +22,8 @@
 using System;
 using HeuristicLab.Common;
+using HEAL.Fossil;
 
 namespace HeuristicLab.Operators.Views.GraphVisualization {
+  [StorableType("3cdcae5a-9f9f-4b99-bcd7-cc9619a547d8")]
   public interface IConnectionInfo : IDeepCloneable {
     IShapeInfo From { get; }
Index: /branches/2520_PersistenceReintegration/HeuristicLab.Operators.Views.GraphVisualization/3.3/General/IGraphVisualizationInfo.cs
===================================================================
--- /branches/2520_PersistenceReintegration/HeuristicLab.Operators.Views.GraphVisualization/3.3/General/IGraphVisualizationInfo.cs	(revision 16475)
+++ /branches/2520_PersistenceReintegration/HeuristicLab.Operators.Views.GraphVisualization/3.3/General/IGraphVisualizationInfo.cs	(revision 16476)
@@ -24,6 +24,8 @@
 using HeuristicLab.Collections;
 using HeuristicLab.Common;
+using HEAL.Fossil;
 
 namespace HeuristicLab.Operators.Views.GraphVisualization {
+  [StorableType("d6df3b9d-453c-4f85-ae4b-76c3cbcc304c")]
   public interface IGraphVisualizationInfo : IDeepCloneable, IContent {
     IShapeInfo InitialShape { get; set; }
Index: /branches/2520_PersistenceReintegration/HeuristicLab.Operators.Views.GraphVisualization/3.3/General/IShapeInfo.cs
===================================================================
--- /branches/2520_PersistenceReintegration/HeuristicLab.Operators.Views.GraphVisualization/3.3/General/IShapeInfo.cs	(revision 16475)
+++ /branches/2520_PersistenceReintegration/HeuristicLab.Operators.Views.GraphVisualization/3.3/General/IShapeInfo.cs	(revision 16476)
@@ -24,6 +24,8 @@
 using System.Drawing;
 using HeuristicLab.Common;
+using HEAL.Fossil;
 
 namespace HeuristicLab.Operators.Views.GraphVisualization {
+  [StorableType("a4ab29fa-705b-4a49-8ca2-86a18b40de12")]
   public interface IShapeInfo : IDeepCloneable {
     Point Location { get; set; }
Index: /branches/2520_PersistenceReintegration/HeuristicLab.Operators.Views.GraphVisualization/3.3/OperatorGraphVisualization/IOperatorShapeInfo.cs
===================================================================
--- /branches/2520_PersistenceReintegration/HeuristicLab.Operators.Views.GraphVisualization/3.3/OperatorGraphVisualization/IOperatorShapeInfo.cs	(revision 16475)
+++ /branches/2520_PersistenceReintegration/HeuristicLab.Operators.Views.GraphVisualization/3.3/OperatorGraphVisualization/IOperatorShapeInfo.cs	(revision 16476)
@@ -22,6 +22,8 @@
 using System.Collections.Generic;
 using System.Drawing;
+using HEAL.Fossil;
 
 namespace HeuristicLab.Operators.Views.GraphVisualization {
+  [StorableType("d6ae073c-ddf7-4923-abed-1b3c864ac492")]
   public interface IOperatorShapeInfo : IShapeInfo {
     bool Collapsed { get; set; }
Index: /branches/2520_PersistenceReintegration/HeuristicLab.Operators.Views.GraphVisualization/3.3/OperatorGraphVisualization/OperatorShape.cs
===================================================================
--- /branches/2520_PersistenceReintegration/HeuristicLab.Operators.Views.GraphVisualization/3.3/OperatorGraphVisualization/OperatorShape.cs	(revision 16475)
+++ /branches/2520_PersistenceReintegration/HeuristicLab.Operators.Views.GraphVisualization/3.3/OperatorGraphVisualization/OperatorShape.cs	(revision 16476)
@@ -1,3 +1,4 @@
-﻿#region License Information
+﻿using HEAL.Fossil;
+#region License Information
 /* HeuristicLab
  * Copyright (C) 2002-2019 Heuristic and Evolutionary Algorithms Laboratory (HEAL)
@@ -23,4 +24,5 @@
 
 namespace HeuristicLab.Operators.Views.GraphVisualization {
+  [StorableType("5a5d76a6-607b-418b-9de1-e30ea3e85f58")]
   internal class OperatorShape {
     //21.04.2011 mkommend
Index: /branches/2520_PersistenceReintegration/HeuristicLab.Operators/3.3/ReductionOperation.cs
===================================================================
--- /branches/2520_PersistenceReintegration/HeuristicLab.Operators/3.3/ReductionOperation.cs	(revision 16475)
+++ /branches/2520_PersistenceReintegration/HeuristicLab.Operators/3.3/ReductionOperation.cs	(revision 16476)
@@ -27,4 +27,5 @@
 
 namespace HeuristicLab.Operators {
+  [StorableType("1080f82a-f4cd-41db-a474-6578a4b9ec82")]
   public enum ReductionOperations {
     Sum,
Index: /branches/2520_PersistenceReintegration/HeuristicLab.Optimization.Operators/3.3/MultiObjective/CrowdedComparisonSorter.cs
===================================================================
--- /branches/2520_PersistenceReintegration/HeuristicLab.Optimization.Operators/3.3/MultiObjective/CrowdedComparisonSorter.cs	(revision 16475)
+++ /branches/2520_PersistenceReintegration/HeuristicLab.Optimization.Operators/3.3/MultiObjective/CrowdedComparisonSorter.cs	(revision 16476)
@@ -69,4 +69,5 @@
     }
 
+    [StorableType("c16dd393-bd08-4a81-abb5-1b7e918a1038")]
     private class CustomComparer : IComparer<int> {
       ItemArray<IntValue> ranks;
Index: /branches/2520_PersistenceReintegration/HeuristicLab.Optimization.Operators/3.3/MultiObjective/CrowdingDistanceAssignment.cs
===================================================================
--- /branches/2520_PersistenceReintegration/HeuristicLab.Optimization.Operators/3.3/MultiObjective/CrowdingDistanceAssignment.cs	(revision 16475)
+++ /branches/2520_PersistenceReintegration/HeuristicLab.Optimization.Operators/3.3/MultiObjective/CrowdingDistanceAssignment.cs	(revision 16476)
@@ -103,4 +103,5 @@
     }
 
+    [StorableType("30fd1927-b268-4ce7-8960-b04bfa83f1e6")]
     private class QualitiesComparer : IComparer<DoubleArray> {
       private int index;
Index: /branches/2520_PersistenceReintegration/HeuristicLab.Optimization.Operators/3.3/NoSimilarityCalculator.cs
===================================================================
--- /branches/2520_PersistenceReintegration/HeuristicLab.Optimization.Operators/3.3/NoSimilarityCalculator.cs	(revision 16475)
+++ /branches/2520_PersistenceReintegration/HeuristicLab.Optimization.Operators/3.3/NoSimilarityCalculator.cs	(revision 16476)
@@ -32,4 +32,5 @@
   /// </remarks>
   [Item("NoSimilarityCalculator", "An item that performs similarity calculation between two solutions. The item always considers two solutions to be distinct.")]
+  [StorableType("dd0dc63b-f691-4132-963e-eab3e1bc366a")]
   public sealed class NoSimilarityCalculator : SingleObjectiveSolutionSimilarityCalculator {
     protected override bool IsCommutative { get { return true; } }
Index: /branches/2520_PersistenceReintegration/HeuristicLab.Optimization.Operators/3.3/QualitySimilarityCalculator.cs
===================================================================
--- /branches/2520_PersistenceReintegration/HeuristicLab.Optimization.Operators/3.3/QualitySimilarityCalculator.cs	(revision 16475)
+++ /branches/2520_PersistenceReintegration/HeuristicLab.Optimization.Operators/3.3/QualitySimilarityCalculator.cs	(revision 16476)
@@ -34,4 +34,5 @@
   /// </remarks>
   [Item("QualitySimilarityCalculator", "An item that performs similarity calculation between two solutions. The item only considers the qualities of the two solutions.")]
+  [StorableType("b5ef2b97-4a4a-43cd-aeae-7f951b49cdc1")]
   public sealed class QualitySimilarityCalculator : SingleObjectiveSolutionSimilarityCalculator {
     protected override bool IsCommutative { get { return true; } }
Index: /branches/2520_PersistenceReintegration/HeuristicLab.Optimization/3.3/BasicProblems/Individuals/Individual.cs
===================================================================
--- /branches/2520_PersistenceReintegration/HeuristicLab.Optimization/3.3/BasicProblems/Individuals/Individual.cs	(revision 16475)
+++ /branches/2520_PersistenceReintegration/HeuristicLab.Optimization/3.3/BasicProblems/Individuals/Individual.cs	(revision 16476)
@@ -24,10 +24,19 @@
 using System.Linq;
 using HeuristicLab.Core;
+using HEAL.Fossil;
 
 namespace HeuristicLab.Optimization {
+  [StorableType("b1388a9d-c85c-49f6-9916-ef4c93dffee0")]
   public abstract class Individual {
+    [Storable]
     protected IEncoding Encoding { get; private set; }
+    [Storable]
     protected IScope Scope { get; private set; }
     public string Name { get { return Encoding.Name; } }
+
+
+    [StorableConstructor]
+    protected Individual(StorableConstructorFlag _) {
+    }
 
     protected Individual(IEncoding encoding, IScope scope) {
Index: /branches/2520_PersistenceReintegration/HeuristicLab.Optimization/3.3/BasicProblems/Individuals/MultiEncodingIndividual.cs
===================================================================
--- /branches/2520_PersistenceReintegration/HeuristicLab.Optimization/3.3/BasicProblems/Individuals/MultiEncodingIndividual.cs	(revision 16475)
+++ /branches/2520_PersistenceReintegration/HeuristicLab.Optimization/3.3/BasicProblems/Individuals/MultiEncodingIndividual.cs	(revision 16476)
@@ -24,9 +24,15 @@
 using HeuristicLab.Common;
 using HeuristicLab.Core;
+using HEAL.Fossil;
 
 namespace HeuristicLab.Optimization {
+  [StorableType("ec7201c7-3c9f-4a93-966b-d848d9538202")]
   public sealed class MultiEncodingIndividual : Individual {
     private new MultiEncoding Encoding {
       get { return (MultiEncoding)base.Encoding; }
+    }
+
+    [StorableConstructor]
+    private MultiEncodingIndividual(StorableConstructorFlag _) : base(_) {
     }
 
Index: /branches/2520_PersistenceReintegration/HeuristicLab.Optimization/3.3/BasicProblems/Individuals/SingleEncodingIndividual.cs
===================================================================
--- /branches/2520_PersistenceReintegration/HeuristicLab.Optimization/3.3/BasicProblems/Individuals/SingleEncodingIndividual.cs	(revision 16475)
+++ /branches/2520_PersistenceReintegration/HeuristicLab.Optimization/3.3/BasicProblems/Individuals/SingleEncodingIndividual.cs	(revision 16476)
@@ -23,7 +23,13 @@
 using HeuristicLab.Common;
 using HeuristicLab.Core;
+using HEAL.Fossil;
 
 namespace HeuristicLab.Optimization {
+  [StorableType("13a86161-9e5c-442b-ab1c-18018b1d9708")]
   public sealed class SingleEncodingIndividual : Individual {
+    [StorableConstructor]
+    private SingleEncodingIndividual(StorableConstructorFlag _) : base(_) {
+    }
+
     public SingleEncodingIndividual(IEncoding encoding, IScope scope)
       : base(encoding, scope) {
Index: /branches/2520_PersistenceReintegration/HeuristicLab.Optimization/3.3/BasicProblems/Interfaces/IEncoding.cs
===================================================================
--- /branches/2520_PersistenceReintegration/HeuristicLab.Optimization/3.3/BasicProblems/Interfaces/IEncoding.cs	(revision 16475)
+++ /branches/2520_PersistenceReintegration/HeuristicLab.Optimization/3.3/BasicProblems/Interfaces/IEncoding.cs	(revision 16476)
@@ -23,6 +23,8 @@
 using System.Collections.Generic;
 using HeuristicLab.Core;
+using HEAL.Fossil;
 
 namespace HeuristicLab.Optimization {
+  [StorableType("d70b2675-246c-489c-a91b-b2e19a1616a3")]
   public interface IEncoding : IParameterizedNamedItem {
     ISolutionCreator SolutionCreator { get; set; }
Index: /branches/2520_PersistenceReintegration/HeuristicLab.Optimization/3.3/BasicProblems/Interfaces/IEncodingOperator.cs
===================================================================
--- /branches/2520_PersistenceReintegration/HeuristicLab.Optimization/3.3/BasicProblems/Interfaces/IEncodingOperator.cs	(revision 16475)
+++ /branches/2520_PersistenceReintegration/HeuristicLab.Optimization/3.3/BasicProblems/Interfaces/IEncodingOperator.cs	(revision 16476)
@@ -21,6 +21,8 @@
 
 using HeuristicLab.Core;
+using HEAL.Fossil;
 
 namespace HeuristicLab.Optimization {
+  [StorableType("20faaf8b-dd4f-4f0e-a772-4c4dec7fcccb")]
   public interface IEncodingOperator : IOperator {
     ILookupParameter<IEncoding> EncodingParameter { get; }
Index: /branches/2520_PersistenceReintegration/HeuristicLab.Optimization/3.3/BasicProblems/Interfaces/IMultiEncodingOperator.cs
===================================================================
--- /branches/2520_PersistenceReintegration/HeuristicLab.Optimization/3.3/BasicProblems/Interfaces/IMultiEncodingOperator.cs	(revision 16475)
+++ /branches/2520_PersistenceReintegration/HeuristicLab.Optimization/3.3/BasicProblems/Interfaces/IMultiEncodingOperator.cs	(revision 16476)
@@ -21,6 +21,8 @@
 
 using HeuristicLab.Core;
+using HEAL.Fossil;
 
 namespace HeuristicLab.Optimization {
+  [StorableType("e8b66565-263c-49f9-9c08-29b820bf3e5a")]
   public interface IMultiEncodingOperator : IOperator {
     void AddEncoding(IEncoding encoding);
Index: /branches/2520_PersistenceReintegration/HeuristicLab.Optimization/3.3/BasicProblems/Interfaces/IMultiObjectiveProblemDefinition.cs
===================================================================
--- /branches/2520_PersistenceReintegration/HeuristicLab.Optimization/3.3/BasicProblems/Interfaces/IMultiObjectiveProblemDefinition.cs	(revision 16475)
+++ /branches/2520_PersistenceReintegration/HeuristicLab.Optimization/3.3/BasicProblems/Interfaces/IMultiObjectiveProblemDefinition.cs	(revision 16476)
@@ -21,6 +21,8 @@
 
 using HeuristicLab.Core;
+using HEAL.Fossil;
 
 namespace HeuristicLab.Optimization {
+  [StorableType("39eacdb5-80a0-425d-902a-00eb3e1d6610")]
   public interface IMultiObjectiveProblemDefinition : IProblemDefinition {
     bool[] Maximization { get; }
Index: /branches/2520_PersistenceReintegration/HeuristicLab.Optimization/3.3/BasicProblems/Interfaces/IProblemDefinition.cs
===================================================================
--- /branches/2520_PersistenceReintegration/HeuristicLab.Optimization/3.3/BasicProblems/Interfaces/IProblemDefinition.cs	(revision 16475)
+++ /branches/2520_PersistenceReintegration/HeuristicLab.Optimization/3.3/BasicProblems/Interfaces/IProblemDefinition.cs	(revision 16476)
@@ -1,3 +1,4 @@
-﻿#region License Information
+﻿using HEAL.Fossil;
+#region License Information
 /* HeuristicLab
  * Copyright (C) 2002-2019 Heuristic and Evolutionary Algorithms Laboratory (HEAL)
@@ -21,4 +22,5 @@
 
 namespace HeuristicLab.Optimization {
+  [StorableType("747a3cea-b9ba-4322-a5c2-050cd7e16e2a")]
   public interface IProblemDefinition {
     IEncoding Encoding { get; }
Index: /branches/2520_PersistenceReintegration/HeuristicLab.Optimization/3.3/BasicProblems/Interfaces/ISingleObjectiveMoveOperator.cs
===================================================================
--- /branches/2520_PersistenceReintegration/HeuristicLab.Optimization/3.3/BasicProblems/Interfaces/ISingleObjectiveMoveOperator.cs	(revision 16475)
+++ /branches/2520_PersistenceReintegration/HeuristicLab.Optimization/3.3/BasicProblems/Interfaces/ISingleObjectiveMoveOperator.cs	(revision 16476)
@@ -1,3 +1,4 @@
-﻿#region License Information
+﻿using HEAL.Fossil;
+#region License Information
 /* HeuristicLab
  * Copyright (C) 2002-2019 Heuristic and Evolutionary Algorithms Laboratory (HEAL)
@@ -21,4 +22,5 @@
 
 namespace HeuristicLab.Optimization {
+  [StorableType("82423b2f-1343-4a21-847c-e69bdcde4861")]
   public interface ISingleObjectiveMoveOperator : IMoveOperator, ISingleObjectiveOperator {
   }
Index: /branches/2520_PersistenceReintegration/HeuristicLab.Optimization/3.3/BasicProblems/Interfaces/ISingleObjectiveProblemDefinition.cs
===================================================================
--- /branches/2520_PersistenceReintegration/HeuristicLab.Optimization/3.3/BasicProblems/Interfaces/ISingleObjectiveProblemDefinition.cs	(revision 16475)
+++ /branches/2520_PersistenceReintegration/HeuristicLab.Optimization/3.3/BasicProblems/Interfaces/ISingleObjectiveProblemDefinition.cs	(revision 16476)
@@ -22,6 +22,8 @@
 using System.Collections.Generic;
 using HeuristicLab.Core;
+using HEAL.Fossil;
 
 namespace HeuristicLab.Optimization {
+  [StorableType("7ec7bf7e-aaa7-4681-828b-3401cf67e2b3")]
   public interface ISingleObjectiveProblemDefinition : IProblemDefinition {
     bool Maximization { get; }
Index: /branches/2520_PersistenceReintegration/HeuristicLab.Optimization/3.3/BasicProblems/Interfaces/internal/IMultiObjectiveAnalysisOperator.cs
===================================================================
--- /branches/2520_PersistenceReintegration/HeuristicLab.Optimization/3.3/BasicProblems/Interfaces/internal/IMultiObjectiveAnalysisOperator.cs	(revision 16475)
+++ /branches/2520_PersistenceReintegration/HeuristicLab.Optimization/3.3/BasicProblems/Interfaces/internal/IMultiObjectiveAnalysisOperator.cs	(revision 16476)
@@ -22,6 +22,8 @@
 using System;
 using HeuristicLab.Core;
+using HEAL.Fossil;
 
 namespace HeuristicLab.Optimization {
+  [StorableType("c9325602-3262-48a4-8985-03657fb0b34f")]
   internal interface IMultiObjectiveAnalysisOperator : IEncodingOperator, IAnalyzer, IMultiObjectiveOperator {
     Action<Individual[], double[][], ResultCollection, IRandom> AnalyzeAction { get; set; }
Index: /branches/2520_PersistenceReintegration/HeuristicLab.Optimization/3.3/BasicProblems/Interfaces/internal/IMultiObjectiveEvaluationOperator.cs
===================================================================
--- /branches/2520_PersistenceReintegration/HeuristicLab.Optimization/3.3/BasicProblems/Interfaces/internal/IMultiObjectiveEvaluationOperator.cs	(revision 16475)
+++ /branches/2520_PersistenceReintegration/HeuristicLab.Optimization/3.3/BasicProblems/Interfaces/internal/IMultiObjectiveEvaluationOperator.cs	(revision 16476)
@@ -22,6 +22,8 @@
 using System;
 using HeuristicLab.Core;
+using HEAL.Fossil;
 
 namespace HeuristicLab.Optimization {
+  [StorableType("89da568c-70a2-48fb-8e6b-ea078bb6fc3f")]
   internal interface IMultiObjectiveEvaluationOperator : IMultiObjectiveEvaluator, IEncodingOperator {
     Func<Individual, IRandom, double[]> EvaluateFunc { get; set; }
Index: /branches/2520_PersistenceReintegration/HeuristicLab.Optimization/3.3/BasicProblems/Interfaces/internal/INeighborBasedOperator.cs
===================================================================
--- /branches/2520_PersistenceReintegration/HeuristicLab.Optimization/3.3/BasicProblems/Interfaces/internal/INeighborBasedOperator.cs	(revision 16475)
+++ /branches/2520_PersistenceReintegration/HeuristicLab.Optimization/3.3/BasicProblems/Interfaces/internal/INeighborBasedOperator.cs	(revision 16476)
@@ -23,6 +23,8 @@
 using System.Collections.Generic;
 using HeuristicLab.Core;
+using HEAL.Fossil;
 
 namespace HeuristicLab.Optimization {
+  [StorableType("fda56e0b-9392-4711-9af1-55211bfa24ac")]
   internal interface INeighborBasedOperator : IEncodingOperator {
     Func<Individual, IRandom, IEnumerable<Individual>> GetNeighborsFunc { get; set; }
Index: /branches/2520_PersistenceReintegration/HeuristicLab.Optimization/3.3/BasicProblems/Interfaces/internal/ISingleObjectiveAnalysisOperator.cs
===================================================================
--- /branches/2520_PersistenceReintegration/HeuristicLab.Optimization/3.3/BasicProblems/Interfaces/internal/ISingleObjectiveAnalysisOperator.cs	(revision 16475)
+++ /branches/2520_PersistenceReintegration/HeuristicLab.Optimization/3.3/BasicProblems/Interfaces/internal/ISingleObjectiveAnalysisOperator.cs	(revision 16476)
@@ -22,6 +22,8 @@
 using System;
 using HeuristicLab.Core;
+using HEAL.Fossil;
 
 namespace HeuristicLab.Optimization {
+  [StorableType("9731981c-10c6-4850-9308-a4720ac07da7")]
   internal interface ISingleObjectiveAnalysisOperator : IEncodingOperator, ISingleObjectiveOperator {
     Action<Individual[], double[], ResultCollection, IRandom> AnalyzeAction { get; set; }
Index: /branches/2520_PersistenceReintegration/HeuristicLab.Optimization/3.3/BasicProblems/Interfaces/internal/ISingleObjectiveEvaluationOperator.cs
===================================================================
--- /branches/2520_PersistenceReintegration/HeuristicLab.Optimization/3.3/BasicProblems/Interfaces/internal/ISingleObjectiveEvaluationOperator.cs	(revision 16475)
+++ /branches/2520_PersistenceReintegration/HeuristicLab.Optimization/3.3/BasicProblems/Interfaces/internal/ISingleObjectiveEvaluationOperator.cs	(revision 16476)
@@ -22,6 +22,8 @@
 using System;
 using HeuristicLab.Core;
+using HEAL.Fossil;
 
 namespace HeuristicLab.Optimization {
+  [StorableType("5a9cf334-4815-4f0e-a2f8-f3d4edfcc829")]
   internal interface ISingleObjectiveEvaluationOperator : ISingleObjectiveEvaluator, IEncodingOperator {
     Func<Individual, IRandom, double> EvaluateFunc { get; set; }
Index: /branches/2520_PersistenceReintegration/HeuristicLab.Optimization/3.3/Interfaces/IAlgorithm.cs
===================================================================
--- /branches/2520_PersistenceReintegration/HeuristicLab.Optimization/3.3/Interfaces/IAlgorithm.cs	(revision 16475)
+++ /branches/2520_PersistenceReintegration/HeuristicLab.Optimization/3.3/Interfaces/IAlgorithm.cs	(revision 16476)
@@ -23,6 +23,8 @@
 using System.Collections.Generic;
 using HeuristicLab.Core;
+using HEAL.Fossil;
 
 namespace HeuristicLab.Optimization {
+  [StorableType("c293d208-59ac-4d3c-b815-47d68355628d")]
   /// <summary>
   /// Interface to represent an algorithm.
Index: /branches/2520_PersistenceReintegration/HeuristicLab.Optimization/3.3/Interfaces/IAnalyzer.cs
===================================================================
--- /branches/2520_PersistenceReintegration/HeuristicLab.Optimization/3.3/Interfaces/IAnalyzer.cs	(revision 16475)
+++ /branches/2520_PersistenceReintegration/HeuristicLab.Optimization/3.3/Interfaces/IAnalyzer.cs	(revision 16476)
@@ -21,6 +21,8 @@
 
 using HeuristicLab.Core;
+using HEAL.Fossil;
 
 namespace HeuristicLab.Optimization {
+  [StorableType("eefee3ee-96ea-41fe-af01-ef96961c99b4")]
   /// <summary>
   /// An interface which represents an analysis operator.
Index: /branches/2520_PersistenceReintegration/HeuristicLab.Optimization/3.3/Interfaces/ICharacteristicCalculator.cs
===================================================================
--- /branches/2520_PersistenceReintegration/HeuristicLab.Optimization/3.3/Interfaces/ICharacteristicCalculator.cs	(revision 16475)
+++ /branches/2520_PersistenceReintegration/HeuristicLab.Optimization/3.3/Interfaces/ICharacteristicCalculator.cs	(revision 16476)
@@ -23,6 +23,8 @@
 using HeuristicLab.Core;
 using HeuristicLab.Data;
+using HEAL.Fossil;
 
 namespace HeuristicLab.Optimization {
+  [StorableType("7125fc8c-2323-423c-8b08-76f80e4e119e")]
   public interface ICharacteristicCalculator : IParameterizedNamedItem {
     IProblem Problem { get; set; }
Index: /branches/2520_PersistenceReintegration/HeuristicLab.Optimization/3.3/Interfaces/ICrossover.cs
===================================================================
--- /branches/2520_PersistenceReintegration/HeuristicLab.Optimization/3.3/Interfaces/ICrossover.cs	(revision 16475)
+++ /branches/2520_PersistenceReintegration/HeuristicLab.Optimization/3.3/Interfaces/ICrossover.cs	(revision 16476)
@@ -21,6 +21,8 @@
 
 using HeuristicLab.Core;
+using HEAL.Fossil;
 
 namespace HeuristicLab.Optimization {
+  [StorableType("0eb07054-a63b-4f31-9a2a-6dae28204d82")]
   /// <summary>
   /// An interface which represents an operator for crossing solutions.
Index: /branches/2520_PersistenceReintegration/HeuristicLab.Optimization/3.3/Interfaces/IDiscreteDoubleMatrixModifier.cs
===================================================================
--- /branches/2520_PersistenceReintegration/HeuristicLab.Optimization/3.3/Interfaces/IDiscreteDoubleMatrixModifier.cs	(revision 16475)
+++ /branches/2520_PersistenceReintegration/HeuristicLab.Optimization/3.3/Interfaces/IDiscreteDoubleMatrixModifier.cs	(revision 16476)
@@ -23,6 +23,8 @@
 using HeuristicLab.Data;
 using HeuristicLab.Parameters;
+using HEAL.Fossil;
 
 namespace HeuristicLab.Optimization {
+  [StorableType("75135b74-abed-4426-aacd-dd2eb4ea1188")]
   public interface IDiscreteDoubleMatrixModifier : IOperator {
     ILookupParameter<DoubleMatrix> ValueParameter { get; }
Index: /branches/2520_PersistenceReintegration/HeuristicLab.Optimization/3.3/Interfaces/IDiscreteDoubleValueModifier.cs
===================================================================
--- /branches/2520_PersistenceReintegration/HeuristicLab.Optimization/3.3/Interfaces/IDiscreteDoubleValueModifier.cs	(revision 16475)
+++ /branches/2520_PersistenceReintegration/HeuristicLab.Optimization/3.3/Interfaces/IDiscreteDoubleValueModifier.cs	(revision 16476)
@@ -22,6 +22,8 @@
 using HeuristicLab.Core;
 using HeuristicLab.Data;
+using HEAL.Fossil;
 
 namespace HeuristicLab.Optimization {
+  [StorableType("32f2e082-9d02-4006-85d5-d2006cb47def")]
   public interface IDiscreteDoubleValueModifier : IOperator {
     ILookupParameter<DoubleValue> ValueParameter { get; }
Index: /branches/2520_PersistenceReintegration/HeuristicLab.Optimization/3.3/Interfaces/IEvaluator.cs
===================================================================
--- /branches/2520_PersistenceReintegration/HeuristicLab.Optimization/3.3/Interfaces/IEvaluator.cs	(revision 16475)
+++ /branches/2520_PersistenceReintegration/HeuristicLab.Optimization/3.3/Interfaces/IEvaluator.cs	(revision 16476)
@@ -21,6 +21,8 @@
 
 using HeuristicLab.Core;
+using HEAL.Fossil;
 
 namespace HeuristicLab.Optimization {
+  [StorableType("bfd1c015-ab11-483c-a5ce-fddac47faea6")]
   /// <summary>
   /// An interface which represents an evaluation operator for optimization problems.
Index: /branches/2520_PersistenceReintegration/HeuristicLab.Optimization/3.3/Interfaces/IExhaustiveMoveGenerator.cs
===================================================================
--- /branches/2520_PersistenceReintegration/HeuristicLab.Optimization/3.3/Interfaces/IExhaustiveMoveGenerator.cs	(revision 16475)
+++ /branches/2520_PersistenceReintegration/HeuristicLab.Optimization/3.3/Interfaces/IExhaustiveMoveGenerator.cs	(revision 16476)
@@ -1,3 +1,4 @@
-﻿#region License Information
+﻿using HEAL.Fossil;
+#region License Information
 /* HeuristicLab
  * Copyright (C) 2002-2019 Heuristic and Evolutionary Algorithms Laboratory (HEAL)
@@ -21,4 +22,5 @@
 
 namespace HeuristicLab.Optimization {
+  [StorableType("0e75b461-71a9-4070-9bbd-6ca20fadf773")]
   public interface IExhaustiveMoveGenerator : IMoveGenerator {
   }
Index: /branches/2520_PersistenceReintegration/HeuristicLab.Optimization/3.3/Interfaces/IHeuristicOptimizationProblem.cs
===================================================================
--- /branches/2520_PersistenceReintegration/HeuristicLab.Optimization/3.3/Interfaces/IHeuristicOptimizationProblem.cs	(revision 16475)
+++ /branches/2520_PersistenceReintegration/HeuristicLab.Optimization/3.3/Interfaces/IHeuristicOptimizationProblem.cs	(revision 16476)
@@ -22,6 +22,8 @@
 using System;
 using HeuristicLab.Core;
+using HEAL.Fossil;
 
 namespace HeuristicLab.Optimization {
+  [StorableType("51d66e7a-e4bd-429a-b6e5-1cfe9ce4364f")]
   /// <summary>
   /// Interface to represent a heuristic optimization problem.
Index: /branches/2520_PersistenceReintegration/HeuristicLab.Optimization/3.3/Interfaces/IImprovementOperator.cs
===================================================================
--- /branches/2520_PersistenceReintegration/HeuristicLab.Optimization/3.3/Interfaces/IImprovementOperator.cs	(revision 16475)
+++ /branches/2520_PersistenceReintegration/HeuristicLab.Optimization/3.3/Interfaces/IImprovementOperator.cs	(revision 16476)
@@ -21,6 +21,8 @@
 
 using HeuristicLab.Core;
+using HEAL.Fossil;
 
 namespace HeuristicLab.Optimization {
+  [StorableType("49c24af5-5d38-4dd3-90c6-96bf61da596e")]
   /// <summary>
   /// An interface which represents an operator for improvement.
Index: /branches/2520_PersistenceReintegration/HeuristicLab.Optimization/3.3/Interfaces/IIterationBasedOperator.cs
===================================================================
--- /branches/2520_PersistenceReintegration/HeuristicLab.Optimization/3.3/Interfaces/IIterationBasedOperator.cs	(revision 16475)
+++ /branches/2520_PersistenceReintegration/HeuristicLab.Optimization/3.3/Interfaces/IIterationBasedOperator.cs	(revision 16476)
@@ -22,6 +22,8 @@
 using HeuristicLab.Core;
 using HeuristicLab.Data;
+using HEAL.Fossil;
 
 namespace HeuristicLab.Optimization {
+  [StorableType("7632e886-d410-4b49-98a7-af6799afa15d")]
   public interface IIterationBasedOperator : IOperator {
     ILookupParameter<IntValue> IterationsParameter { get; }
Index: /branches/2520_PersistenceReintegration/HeuristicLab.Optimization/3.3/Interfaces/ILocalImprovementAlgorithmOperator.cs
===================================================================
--- /branches/2520_PersistenceReintegration/HeuristicLab.Optimization/3.3/Interfaces/ILocalImprovementAlgorithmOperator.cs	(revision 16475)
+++ /branches/2520_PersistenceReintegration/HeuristicLab.Optimization/3.3/Interfaces/ILocalImprovementAlgorithmOperator.cs	(revision 16476)
@@ -21,6 +21,8 @@
 
 using System;
+using HEAL.Fossil;
 
 namespace HeuristicLab.Optimization {
+  [StorableType("a45976c5-caad-4eb6-8150-f168a1ff89f5")]
   public interface ILocalImprovementAlgorithmOperator : ILocalImprovementOperator {
     Type ProblemType { get; }
Index: /branches/2520_PersistenceReintegration/HeuristicLab.Optimization/3.3/Interfaces/ILocalImprovementOperator.cs
===================================================================
--- /branches/2520_PersistenceReintegration/HeuristicLab.Optimization/3.3/Interfaces/ILocalImprovementOperator.cs	(revision 16475)
+++ /branches/2520_PersistenceReintegration/HeuristicLab.Optimization/3.3/Interfaces/ILocalImprovementOperator.cs	(revision 16476)
@@ -22,6 +22,8 @@
 using HeuristicLab.Core;
 using HeuristicLab.Data;
+using HEAL.Fossil;
 
 namespace HeuristicLab.Optimization {
+  [StorableType("2af9c952-58d0-4062-9d9b-e839e4fd244c")]
   public interface ILocalImprovementOperator : IOperator {
     IValueLookupParameter<IntValue> MaximumIterationsParameter { get; }
Index: /branches/2520_PersistenceReintegration/HeuristicLab.Optimization/3.3/Interfaces/IManipulator.cs
===================================================================
--- /branches/2520_PersistenceReintegration/HeuristicLab.Optimization/3.3/Interfaces/IManipulator.cs	(revision 16475)
+++ /branches/2520_PersistenceReintegration/HeuristicLab.Optimization/3.3/Interfaces/IManipulator.cs	(revision 16476)
@@ -21,6 +21,8 @@
 
 using HeuristicLab.Core;
+using HEAL.Fossil;
 
 namespace HeuristicLab.Optimization {
+  [StorableType("1bc59173-67b9-45dd-a4ad-a1bd2696659f")]
   /// <summary>
   /// An interface which represents an operator for manipulating solutions.
Index: /branches/2520_PersistenceReintegration/HeuristicLab.Optimization/3.3/Interfaces/IMigrator.cs
===================================================================
--- /branches/2520_PersistenceReintegration/HeuristicLab.Optimization/3.3/Interfaces/IMigrator.cs	(revision 16475)
+++ /branches/2520_PersistenceReintegration/HeuristicLab.Optimization/3.3/Interfaces/IMigrator.cs	(revision 16476)
@@ -21,6 +21,8 @@
 
 using HeuristicLab.Core;
+using HEAL.Fossil;
 
 namespace HeuristicLab.Optimization {
+  [StorableType("5388ce48-00ec-4640-9925-97bf061ad595")]
   public interface IMigrator : IOperator { }
 }
